<?php
/*
....
*/

if( !class_exists( 'CPCFF_BaseAddon' ) )
{
    class CPCFF_BaseAddon
    {
        /************* ADDON SYSTEM - ATTRIBUTES AND METHODS *************/
		protected $addonID;
		protected $name;
		protected $description;

		protected function _run_update_database($db_queries)
		{
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($db_queries); // Running the queries
		}

		protected function update_database()
		{

		}

		public function activate()
		{
			$this->update_database();
		}

		public function get_addon_id()
		{
			return $this->addonID;
		}

		public function get_addon_name()
		{
			return $this->name;
		}

		public function get_addon_description()
		{
			return $this->description;
		}

		public function get_addon_form_settings( $form_id )
		{
			return '';
		}

		public function get_addon_settings()
		{
			return '';
		}

		public function addon_is_active()
		{
			return CPCFF_ADDONS::is_active($this->get_addon_id());
		}

		// Redefined by the add-ons to delete the different options and drop the corresponding database tables
		public function complete_uninstall()
		{
			return false;
		}
	} // End Class
}
?>